#ifndef _TSINI_H_
#define _TSINI_H_

#define TSINI_VERSION_D1	1
#define TSINI_VERSION_D2	0
#define TSINI_VERSION_D3	2

#define TSINI_CALIBRATION_X1 0
#define TSINI_CALIBRATION_X2 512
#define TSINI_CALIBRATION_X3 1023
#define TSINI_CALIBRATION_Y1 0
#define TSINI_CALIBRATION_Y2 512
#define TSINI_CALIBRATION_Y3 1023

#define TS_CM_4POINT_MODE1 0
#define TS_CM_4POINT_MODE2 1
#define TSINI_CALIBRATION_MODE TS_CM_4POINT_MODE1

#define TSINI_PANEL_DIRECTION 0

#define TS_FS_NO_SOUND       1
#define TS_FS_LIFT_ONLY      2
#define TS_FS_TOUCH_ONLY     3
#define TS_FS_TOUCH_AND_LIFT 4

#define TSINI_TOUCH_BEEP_MODE		TS_FS_TOUCH_AND_LIFT
#define TSINI_TOUCH_BEEP_VOLUME		100
#define TSINI_TOUCH_BEEP_TONE		2468
#define TSINI_TOUCH_BEEP_DURATION	20

#define TS_VB_STREAM     1
#define TS_VB_LIFT_OFF   2
#define TS_VB_TOUCH_DOWN 3
#define TS_VB_DRAG_DROP  4

#define TSINI_VIRTUAL_BUTTON TS_VB_DRAG_DROP

#define TS_RB_FUNCTION_OFF 0
#define TS_RB_FUNCTION_ON  1

#define TS_RB_MODE_MANUAL    0
#define TS_RB_MODE_AUTOMETIC 1

#define TSINI_RIGHT_BUTTON_FUNCTION	TS_RB_FUNCTION_ON
#define TSINI_RIGHT_BUTTON_AUTO_MODE	TS_RB_MODE_AUTOMETIC
#define TSINI_RIGHT_BUTTON_AUTO_STIME 	2
#define TSINI_RIGHT_BUTTON_AUTO_ETIME 	2
#define TSINI_RIGHT_BUTTON_AUTO_BEEP	1
#define TSINI_RIGHT_BUTTON_AUTO_RANGE	32

#endif /* _TSINI_H_ */
