/*
 * callbacks.c
 *
 */


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "calibrate.h"
#include "options.h"

void
on_window_main_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_button_calibration_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	calibrate_start();
}


void
on_button_exit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_window_calibrate_destroy            (GtkObject       *object,
                                        gpointer         user_data)
{
	calibrate_end(CALIB_RESULT_DESTORY);
}


void
on_button_save_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	calibrate_end(CALIB_RESULT_SAVE);
}


void
on_button_redo_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	calibrate_end(CALIB_RESULT_REDO);
}


void
on_button_cancel_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	calibrate_end(CALIB_RESULT_CANCEL);
}

void
on_button_break_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	calibrate_end(CALIB_RESULT_ESCAPE);
}


gboolean
on_window_calibrate_key_press_event    (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
	if ( event->keyval == GDK_Escape  ) {
		calibrate_end(CALIB_RESULT_ESCAPE);
		return TRUE;
	}
	return FALSE;
}


gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(1, widget);
	return TRUE;
}


gboolean
on_drawingarea2_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(2, widget);
	return TRUE;
}


gboolean
on_drawingarea3_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(3, widget);
	return TRUE;
}


gboolean
on_drawingarea4_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(4, widget);
	return TRUE;
}


gboolean
on_drawingarea5_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(5, widget);
	return TRUE;
}


gboolean
on_drawingarea6_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(6, widget);
	return TRUE;
}


gboolean
on_drawingarea7_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(7, widget);
	return TRUE;
}


gboolean
on_drawingarea8_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_mark(8, widget);
	return TRUE;
}


gboolean
on_drawingarea_idel_expose_event       (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	calibrate_draw_idel(widget);
	return TRUE;
}


void
on_window_options_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
	options_end();
	gtk_main_quit();
}


void
on_button_options_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	options_start();

}


void
on_button_default_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	options_button_default_clicked();
}


void
on_button_undo_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	options_button_undo_clicked();
}


void
on_button_apply_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	options_button_apply_clicked();
}


void
on_button_done_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	options_button_done_clicked();
}


void
on_comboboxentry_VB_mode_changed       (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_VB_mode_changed();
}


void
on_comboboxentry_RB_auto_mode_changed  (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_RB_auto_mode_changed();
}


void
on_comboboxentry_RB_auto_stime_changed (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_RB_auto_stime_changed();
}


void
on_comboboxentry_RB_auto_etime_changed (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_RB_auto_etime_changed();
}


void
on_comboboxentry_RB_auto_beep_changed  (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_RB_auto_beep_changed();
}


void
on_comboboxentry_FS_mode_changed       (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_FS_mode_changed();
}


void
on_spinbutton_FS_tone_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
	options_FS_tone_changed();

}


void
on_spinbutton_FS_duration_changed      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	options_FS_duration_changed();
}


void
on_comboboxentry_CP_mode_changed       (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	options_CP_mode_changed();
}

