/*
 * interface.c
 *
 */


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "support.h"

#define HOOKUP_OBJECT(component,widget,name) \
	g_object_set_data_full (G_OBJECT (component), name, \
	gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define HOOKUP_OBJECT_NO_REF(component,widget,name) \
	g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_window_main (void)
{
  GtkWidget *window_main;
  GtkWidget *vbox1;
  GtkWidget *label_main_welcome;
  GtkWidget *label_main_help;
  GtkWidget *scrolledwindow1;
  GtkWidget *treeview_devices;
  GtkWidget *hbox1;
  GtkWidget *button_calibration;
  GtkWidget *alignment10;
  GtkWidget *hbox28;
  GtkWidget *image10;
  GtkWidget *label43;
  GtkWidget *button_options;
  GtkWidget *alignment11;
  GtkWidget *hbox29;
  GtkWidget *image11;
  GtkWidget *label44;
  GtkWidget *button_exit;
  GtkWidget *alignment2;
  GtkWidget *hbox3;
  GtkWidget *image1;
  GtkWidget *label4;

  window_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (window_main, 350, 320);
  gtk_window_set_title (GTK_WINDOW (window_main), _("main"));
  gtk_window_set_position (GTK_WINDOW (window_main), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable (GTK_WINDOW (window_main), FALSE);

  vbox1 = gtk_vbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window_main), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  label_main_welcome = gtk_label_new (_("<span foreground=\"#FF0000\"><b>TSUSB Toucnscreen Control Panel</b></span>"));
  gtk_widget_show (label_main_welcome);
  gtk_box_pack_start (GTK_BOX (vbox1), label_main_welcome, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label_main_welcome, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (label_main_welcome), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label_main_welcome), 0.1, 0.5);
  gtk_misc_set_padding (GTK_MISC (label_main_welcome), 0, 2);

  label_main_help = gtk_label_new (_("Select a connected device from the list:"));
  gtk_widget_show (label_main_help);
  gtk_box_pack_start (GTK_BOX (vbox1), label_main_help, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label_main_help, -1, 17);
  gtk_label_set_use_markup (GTK_LABEL (label_main_help), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label_main_help), 0.12, 0);
  gtk_misc_set_padding (GTK_MISC (label_main_help), 0, 2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (scrolledwindow1, -1, 200);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_SHADOW_IN);

  treeview_devices = gtk_tree_view_new ();
  gtk_widget_show (treeview_devices);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), treeview_devices);
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_devices), FALSE);

  hbox1 = gtk_hbox_new (TRUE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hbox1, -1, 20);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 4);

  button_calibration = gtk_button_new ();
  gtk_widget_show (button_calibration);
  gtk_box_pack_start (GTK_BOX (hbox1), button_calibration, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (button_calibration, FALSE);

  alignment10 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment10);
  gtk_container_add (GTK_CONTAINER (button_calibration), alignment10);

  hbox28 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox28);
  gtk_container_add (GTK_CONTAINER (alignment10), hbox28);

  image10 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image10);
  gtk_box_pack_start (GTK_BOX (hbox28), image10, FALSE, FALSE, 0);

  label43 = gtk_label_new_with_mnemonic (_("_Calibration"));
  gtk_widget_show (label43);
  gtk_box_pack_start (GTK_BOX (hbox28), label43, FALSE, FALSE, 0);

  button_options = gtk_button_new ();
  gtk_widget_show (button_options);
  gtk_box_pack_start (GTK_BOX (hbox1), button_options, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (button_options, FALSE);

  alignment11 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment11);
  gtk_container_add (GTK_CONTAINER (button_options), alignment11);

  hbox29 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox29);
  gtk_container_add (GTK_CONTAINER (alignment11), hbox29);

  image11 = gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image11);
  gtk_box_pack_start (GTK_BOX (hbox29), image11, FALSE, FALSE, 0);

  label44 = gtk_label_new_with_mnemonic (_("_Options"));
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (hbox29), label44, FALSE, FALSE, 0);

  button_exit = gtk_button_new ();
  gtk_widget_show (button_exit);
  gtk_box_pack_start (GTK_BOX (hbox1), button_exit, TRUE, TRUE, 0);

  alignment2 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment2);
  gtk_container_add (GTK_CONTAINER (button_exit), alignment2);

  hbox3 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (alignment2), hbox3);

  image1 = gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox3), image1, FALSE, FALSE, 0);

  label4 = gtk_label_new_with_mnemonic (_("E_xit"));
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox3), label4, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) window_main, "destroy",
                    G_CALLBACK (on_window_main_destroy),
                    NULL);
  g_signal_connect ((gpointer) button_calibration, "clicked",
                    G_CALLBACK (on_button_calibration_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_options, "clicked",
                    G_CALLBACK (on_button_options_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_exit, "clicked",
                    G_CALLBACK (on_button_exit_clicked),
                    NULL);

  HOOKUP_OBJECT_NO_REF (window_main, window_main, "window_main");
  HOOKUP_OBJECT (window_main, vbox1, "vbox1");
  HOOKUP_OBJECT (window_main, label_main_welcome, "label_main_welcome");
  HOOKUP_OBJECT (window_main, label_main_help, "label_main_help");
  HOOKUP_OBJECT (window_main, scrolledwindow1, "scrolledwindow1");
  HOOKUP_OBJECT (window_main, treeview_devices, "treeview_devices");
  HOOKUP_OBJECT (window_main, hbox1, "hbox1");
  HOOKUP_OBJECT (window_main, button_calibration, "button_calibration");
  HOOKUP_OBJECT (window_main, alignment10, "alignment10");
  HOOKUP_OBJECT (window_main, hbox28, "hbox28");
  HOOKUP_OBJECT (window_main, image10, "image10");
  HOOKUP_OBJECT (window_main, label43, "label43");
  HOOKUP_OBJECT (window_main, button_options, "button_options");
  HOOKUP_OBJECT (window_main, alignment11, "alignment11");
  HOOKUP_OBJECT (window_main, hbox29, "hbox29");
  HOOKUP_OBJECT (window_main, image11, "image11");
  HOOKUP_OBJECT (window_main, label44, "label44");
  HOOKUP_OBJECT (window_main, button_exit, "button_exit");
  HOOKUP_OBJECT (window_main, alignment2, "alignment2");
  HOOKUP_OBJECT (window_main, hbox3, "hbox3");
  HOOKUP_OBJECT (window_main, image1, "image1");
  HOOKUP_OBJECT (window_main, label4, "label4");

  return window_main;
}

GtkWidget*
create_window_calibrate (void)
{
  GtkWidget *window_calibrate;
  GtkWidget *vbox2;
  GtkWidget *hbox4;
  GtkWidget *drawingarea1;
  GtkWidget *drawingarea5;
  GtkWidget *drawingarea2;
  GtkWidget *hbox5;
  GtkWidget *drawingarea8;
  GtkWidget *vbox3;
  GtkWidget *label_title;
  GtkWidget *label_version;
  GtkWidget *label_screen;
  GtkWidget *label_help;
  GtkWidget *label_idel;
  GtkWidget *drawingarea_idel;
  GtkWidget *hbox7;
  GtkWidget *button_save;
  GtkWidget *button_redo;
  GtkWidget *button_cancel;
  GtkWidget *button_break;
  GtkWidget *drawingarea6;
  GtkWidget *hbox6;
  GtkWidget *drawingarea4;
  GtkWidget *drawingarea7;
  GtkWidget *drawingarea3;

  window_calibrate = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (window_calibrate, 400, 400);
  gtk_widget_set_events (window_calibrate, GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW (window_calibrate), _("calibration"));
  gtk_window_set_modal (GTK_WINDOW (window_calibrate), TRUE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (window_calibrate), vbox2);

  hbox4 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox4, TRUE, TRUE, 0);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea1);
  gtk_box_pack_start (GTK_BOX (hbox4), drawingarea1, TRUE, TRUE, 0);

  drawingarea5 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea5);
  gtk_box_pack_start (GTK_BOX (hbox4), drawingarea5, TRUE, TRUE, 0);

  drawingarea2 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea2);
  gtk_box_pack_start (GTK_BOX (hbox4), drawingarea2, TRUE, TRUE, 0);

  hbox5 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox5, TRUE, TRUE, 0);

  drawingarea8 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea8);
  gtk_box_pack_start (GTK_BOX (hbox5), drawingarea8, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 2);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (vbox3, 100, 100);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 8);

  label_title = gtk_label_new (_("<span foreground=\"#FF0000\" size=\"x-large\"><b>TSUSB CALIBRATION</b></span>"));
  gtk_widget_show (label_title);
  gtk_box_pack_start (GTK_BOX (vbox3), label_title, FALSE, TRUE, 0);
  gtk_widget_set_size_request (label_title, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (label_title), TRUE);

  label_version = gtk_label_new (_("<span foreground=\"#000000\">Version 1.0.0</span>"));
  gtk_widget_show (label_version);
  gtk_box_pack_start (GTK_BOX (vbox3), label_version, FALSE, TRUE, 0);
  gtk_widget_set_size_request (label_version, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (label_version), TRUE);

  label_screen = gtk_label_new (_("<span foreground=\"#000000\">Screen resolution 1024 x 768</span>"));
  gtk_widget_show (label_screen);
  gtk_box_pack_start (GTK_BOX (vbox3), label_screen, FALSE, TRUE, 0);
  gtk_widget_set_size_request (label_screen, -1, 20);
  gtk_label_set_use_markup (GTK_LABEL (label_screen), TRUE);

  label_help = gtk_label_new (_("<span foreground=\"#006600\">Touch on the center of cross that show on the left-up conner of screen</span>"));
  gtk_widget_show (label_help);
  gtk_box_pack_start (GTK_BOX (vbox3), label_help, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label_help), TRUE);
  gtk_label_set_justify (GTK_LABEL (label_help), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (label_help), TRUE);

  label_idel = gtk_label_new (_("-----------------------------"));
  gtk_widget_show (label_idel);
  gtk_box_pack_start (GTK_BOX (vbox3), label_idel, FALSE, TRUE, 0);
  gtk_widget_set_size_request (label_idel, -1, 15);
  gtk_label_set_use_markup (GTK_LABEL (label_idel), TRUE);

  drawingarea_idel = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea_idel);
  gtk_box_pack_start (GTK_BOX (vbox3), drawingarea_idel, FALSE, TRUE, 0);
  gtk_widget_set_size_request (drawingarea_idel, -1, 12);

  hbox7 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox7, FALSE, TRUE, 0);
  gtk_widget_set_size_request (hbox7, -1, 35);

  button_save = gtk_button_new_with_mnemonic (_("_Save"));
  gtk_widget_show (button_save);
  gtk_box_pack_start (GTK_BOX (hbox7), button_save, TRUE, TRUE, 0);
  gtk_widget_set_size_request (button_save, -1, 15);
  gtk_container_set_border_width (GTK_CONTAINER (button_save), 4);

  button_redo = gtk_button_new_with_mnemonic (_("_Redo"));
  gtk_widget_show (button_redo);
  gtk_box_pack_start (GTK_BOX (hbox7), button_redo, TRUE, TRUE, 0);
  gtk_widget_set_size_request (button_redo, -1, 15);
  gtk_container_set_border_width (GTK_CONTAINER (button_redo), 4);

  button_cancel = gtk_button_new_with_mnemonic (_("_Cancel"));
  gtk_widget_show (button_cancel);
  gtk_box_pack_start (GTK_BOX (hbox7), button_cancel, TRUE, TRUE, 0);
  gtk_widget_set_size_request (button_cancel, -1, 15);
  gtk_container_set_border_width (GTK_CONTAINER (button_cancel), 4);

  button_break = gtk_button_new_with_mnemonic (_("cancel calibration (ESC)"));
  gtk_widget_show (button_break);
  gtk_box_pack_start (GTK_BOX (hbox7), button_break, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_break), 4);

  drawingarea6 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea6);
  gtk_box_pack_start (GTK_BOX (hbox5), drawingarea6, TRUE, TRUE, 0);

  hbox6 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox6, TRUE, TRUE, 0);

  drawingarea4 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea4);
  gtk_box_pack_start (GTK_BOX (hbox6), drawingarea4, TRUE, TRUE, 0);

  drawingarea7 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea7);
  gtk_box_pack_start (GTK_BOX (hbox6), drawingarea7, TRUE, TRUE, 0);

  drawingarea3 = gtk_drawing_area_new ();
  gtk_widget_show (drawingarea3);
  gtk_box_pack_start (GTK_BOX (hbox6), drawingarea3, TRUE, TRUE, 0);

  g_signal_connect ((gpointer) window_calibrate, "destroy",
                    G_CALLBACK (on_window_calibrate_destroy),
                    NULL);
  g_signal_connect ((gpointer) window_calibrate, "key_press_event",
                    G_CALLBACK (on_window_calibrate_key_press_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea1, "expose_event",
                    G_CALLBACK (on_drawingarea1_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea5, "expose_event",
                    G_CALLBACK (on_drawingarea5_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea2, "expose_event",
                    G_CALLBACK (on_drawingarea2_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea8, "expose_event",
                    G_CALLBACK (on_drawingarea8_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea_idel, "expose_event",
                    G_CALLBACK (on_drawingarea_idel_expose_event),
                    NULL);
  g_signal_connect ((gpointer) button_save, "clicked",
                    G_CALLBACK (on_button_save_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_redo, "clicked",
                    G_CALLBACK (on_button_redo_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_cancel, "clicked",
                    G_CALLBACK (on_button_cancel_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_break, "clicked",
                    G_CALLBACK (on_button_break_clicked),
                    NULL);
  g_signal_connect ((gpointer) drawingarea6, "expose_event",
                    G_CALLBACK (on_drawingarea6_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea4, "expose_event",
                    G_CALLBACK (on_drawingarea4_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea7, "expose_event",
                    G_CALLBACK (on_drawingarea7_expose_event),
                    NULL);
  g_signal_connect ((gpointer) drawingarea3, "expose_event",
                    G_CALLBACK (on_drawingarea3_expose_event),
                    NULL);

  HOOKUP_OBJECT_NO_REF (window_calibrate, window_calibrate, "window_calibrate");
  HOOKUP_OBJECT (window_calibrate, vbox2, "vbox2");
  HOOKUP_OBJECT (window_calibrate, hbox4, "hbox4");
  HOOKUP_OBJECT (window_calibrate, drawingarea1, "drawingarea1");
  HOOKUP_OBJECT (window_calibrate, drawingarea5, "drawingarea5");
  HOOKUP_OBJECT (window_calibrate, drawingarea2, "drawingarea2");
  HOOKUP_OBJECT (window_calibrate, hbox5, "hbox5");
  HOOKUP_OBJECT (window_calibrate, drawingarea8, "drawingarea8");
  HOOKUP_OBJECT (window_calibrate, vbox3, "vbox3");
  HOOKUP_OBJECT (window_calibrate, label_title, "label_title");
  HOOKUP_OBJECT (window_calibrate, label_version, "label_version");
  HOOKUP_OBJECT (window_calibrate, label_screen, "label_screen");
  HOOKUP_OBJECT (window_calibrate, label_help, "label_help");
  HOOKUP_OBJECT (window_calibrate, label_idel, "label_idel");
  HOOKUP_OBJECT (window_calibrate, drawingarea_idel, "drawingarea_idel");
  HOOKUP_OBJECT (window_calibrate, hbox7, "hbox7");
  HOOKUP_OBJECT (window_calibrate, button_save, "button_save");
  HOOKUP_OBJECT (window_calibrate, button_redo, "button_redo");
  HOOKUP_OBJECT (window_calibrate, button_cancel, "button_cancel");
  HOOKUP_OBJECT (window_calibrate, button_break, "button_break");
  HOOKUP_OBJECT (window_calibrate, drawingarea6, "drawingarea6");
  HOOKUP_OBJECT (window_calibrate, hbox6, "hbox6");
  HOOKUP_OBJECT (window_calibrate, drawingarea4, "drawingarea4");
  HOOKUP_OBJECT (window_calibrate, drawingarea7, "drawingarea7");
  HOOKUP_OBJECT (window_calibrate, drawingarea3, "drawingarea3");

  return window_calibrate;
}

GtkWidget*
create_window_options (void)
{
  GtkWidget *window_options;
  GtkWidget *vbox4;
  GtkWidget *hseparator2;
  GtkWidget *label50;
  GtkWidget *hseparator6;
  GtkWidget *hbox11;
  GtkWidget *label26;
  GtkWidget *comboboxentry_VB_mode;
  GtkWidget *hseparator3;
  GtkWidget *hbox12;
  GtkWidget *label27;
  GtkWidget *comboboxentry_RB_auto_mode;
  GtkWidget *hbox16;
  GtkWidget *label30;
  GtkWidget *hbox31;
  GtkWidget *comboboxentry_RB_auto_stime;
  GtkWidget *label46;
  GtkWidget *hbox17;
  GtkWidget *label31;
  GtkWidget *hbox30;
  GtkWidget *comboboxentry_RB_auto_etime;
  GtkWidget *label45;
  GtkWidget *hbox18;
  GtkWidget *label32;
  GtkWidget *comboboxentry_RB_auto_beep;
  GtkWidget *hseparator4;
  GtkWidget *hbox13;
  GtkWidget *label28;
  GtkWidget *comboboxentry_FS_mode;
  GtkWidget *hbox19;
  GtkWidget *label34;
  GtkObject *spinbutton_FS_tone_adj;
  GtkWidget *spinbutton_FS_tone;
  GtkWidget *hbox20;
  GtkWidget *label35;
  GtkObject *spinbutton_FS_duration_adj;
  GtkWidget *spinbutton_FS_duration;
  GtkWidget *hseparator5;
  GtkWidget *hbox14;
  GtkWidget *label29;
  GtkWidget *comboboxentry_CP_mode;
  GtkWidget *hseparator1;
  GtkWidget *hbox8;
  GtkWidget *button_default;
  GtkWidget *alignment13;
  GtkWidget *hbox33;
  GtkWidget *image13;
  GtkWidget *label48;
  GtkWidget *button_undo;
  GtkWidget *alignment9;
  GtkWidget *hbox27;
  GtkWidget *image9;
  GtkWidget *label42;
  GtkWidget *button_apply;
  GtkWidget *alignment5;
  GtkWidget *hbox23;
  GtkWidget *image5;
  GtkWidget *label38;
  GtkWidget *button_done;
  GtkWidget *alignment14;
  GtkWidget *hbox34;
  GtkWidget *image14;
  GtkWidget *label49;

  window_options = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window_options), _("options"));
  gtk_window_set_position (GTK_WINDOW (window_options), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable (GTK_WINDOW (window_options), FALSE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (window_options), vbox4);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator2, TRUE, TRUE, 0);

  label50 = gtk_label_new (_("<b>TSUSB Touchscreen Options</b>"));
  gtk_widget_show (label50);
  gtk_box_pack_start (GTK_BOX (vbox4), label50, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label50, -1, 30);
  gtk_label_set_use_markup (GTK_LABEL (label50), TRUE);
  gtk_label_set_justify (GTK_LABEL (label50), GTK_JUSTIFY_CENTER);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_show (hseparator6);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator6, TRUE, TRUE, 0);

  hbox11 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox11, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox11), 8);

  label26 = gtk_label_new (_("Virtual Button"));
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox11), label26, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label26, 160, -1);

  comboboxentry_VB_mode = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_VB_mode);
  gtk_box_pack_start (GTK_BOX (hbox11), comboboxentry_VB_mode, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_VB_mode, 185, -1);
  gtk_container_set_border_width (GTK_CONTAINER (comboboxentry_VB_mode), 4);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_VB_mode), _("Stream Mode"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_VB_mode), _("Lift off Mode"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_VB_mode), _("Touch down Mode"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_VB_mode), _("Drag drop Mode"));

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator3, TRUE, TRUE, 0);

  hbox12 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox12, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox12), 8);

  label27 = gtk_label_new (_("Autometic Right Button"));
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (hbox12), label27, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label27, 160, -1);

  comboboxentry_RB_auto_mode = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_RB_auto_mode);
  gtk_box_pack_start (GTK_BOX (hbox12), comboboxentry_RB_auto_mode, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_RB_auto_mode, 185, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_mode), _("Disabled"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_mode), _("Enabled"));

  hbox16 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox16, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox16), 8);

  label30 = gtk_label_new (_("Toggle-on Timer"));
  gtk_widget_show (label30);
  gtk_box_pack_start (GTK_BOX (hbox16), label30, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label30, 160, -1);

  hbox31 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox31);
  gtk_box_pack_start (GTK_BOX (hbox16), hbox31, FALSE, FALSE, 0);

  comboboxentry_RB_auto_stime = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_RB_auto_stime);
  gtk_box_pack_start (GTK_BOX (hbox31), comboboxentry_RB_auto_stime, FALSE, FALSE, 0);
  gtk_widget_set_size_request (comboboxentry_RB_auto_stime, 100, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("0.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("1.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("2.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("3"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("3.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("4"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("4.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_stime), _("5"));

  label46 = gtk_label_new (_("seconds"));
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox31), label46, FALSE, FALSE, 0);

  hbox17 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox17, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox17), 8);

  label31 = gtk_label_new (_("Toggle-off Timer"));
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (hbox17), label31, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label31, 160, -1);

  hbox30 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (hbox17), hbox30, FALSE, FALSE, 0);

  comboboxentry_RB_auto_etime = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_RB_auto_etime);
  gtk_box_pack_start (GTK_BOX (hbox30), comboboxentry_RB_auto_etime, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_RB_auto_etime, 100, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("0.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("1.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("2.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("3"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("3.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("4"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("4.5"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_etime), _("5"));

  label45 = gtk_label_new (_("seconds"));
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox30), label45, FALSE, FALSE, 0);

  hbox18 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox18, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox18), 8);

  label32 = gtk_label_new (_("Beep When Toggle-on/off"));
  gtk_widget_show (label32);
  gtk_box_pack_start (GTK_BOX (hbox18), label32, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label32, 160, -1);

  comboboxentry_RB_auto_beep = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_RB_auto_beep);
  gtk_box_pack_start (GTK_BOX (hbox18), comboboxentry_RB_auto_beep, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_RB_auto_beep, 185, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_beep), _("Disabled"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_RB_auto_beep), _("Enabled"));

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator4, TRUE, TRUE, 0);

  hbox13 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox13, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox13), 8);

  label28 = gtk_label_new (_("Feedback Sound"));
  gtk_widget_show (label28);
  gtk_box_pack_start (GTK_BOX (hbox13), label28, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label28, 160, -1);

  comboboxentry_FS_mode = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_FS_mode);
  gtk_box_pack_start (GTK_BOX (hbox13), comboboxentry_FS_mode, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_FS_mode, 180, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_FS_mode), _("Slience (no sound)"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_FS_mode), _("Lift off"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_FS_mode), _("Touch down"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_FS_mode), _("Touch down and Lift off"));

  hbox19 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox19);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox19, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox19), 8);

  label34 = gtk_label_new (_("Tone"));
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (hbox19), label34, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label34, 160, -1);

  spinbutton_FS_tone_adj = gtk_adjustment_new (2468, 500, 5000, 1, 500, 500);
  spinbutton_FS_tone = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_FS_tone_adj), 1, 0);
  gtk_widget_show (spinbutton_FS_tone);
  gtk_box_pack_start (GTK_BOX (hbox19), spinbutton_FS_tone, TRUE, TRUE, 0);
  gtk_widget_set_size_request (spinbutton_FS_tone, 185, -1);

  hbox20 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox20, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox20), 8);

  label35 = gtk_label_new (_("Duration"));
  gtk_widget_show (label35);
  gtk_box_pack_start (GTK_BOX (hbox20), label35, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label35, 160, -1);

  spinbutton_FS_duration_adj = gtk_adjustment_new (16, 10, 50, 1, 10, 10);
  spinbutton_FS_duration = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_FS_duration_adj), 1, 0);
  gtk_widget_show (spinbutton_FS_duration);
  gtk_box_pack_start (GTK_BOX (hbox20), spinbutton_FS_duration, TRUE, TRUE, 0);
  gtk_widget_set_size_request (spinbutton_FS_duration, 185, -1);

  hseparator5 = gtk_hseparator_new ();
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator5, TRUE, TRUE, 0);

  hbox14 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox14, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox14), 8);

  label29 = gtk_label_new (_("Calibration Mode"));
  gtk_widget_show (label29);
  gtk_box_pack_start (GTK_BOX (hbox14), label29, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label29, 160, -1);

  comboboxentry_CP_mode = gtk_combo_box_entry_new_text ();
  gtk_widget_show (comboboxentry_CP_mode);
  gtk_box_pack_start (GTK_BOX (hbox14), comboboxentry_CP_mode, TRUE, TRUE, 0);
  gtk_widget_set_size_request (comboboxentry_CP_mode, 185, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_CP_mode), _("4 Points Mode 1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (comboboxentry_CP_mode), _("4 Points Mode 2"));

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox4), hseparator1, FALSE, TRUE, 0);

  hbox8 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox8, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox8), 8);

  button_default = gtk_button_new ();
  gtk_widget_show (button_default);
  gtk_box_pack_start (GTK_BOX (hbox8), button_default, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_default), 4);

  alignment13 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment13);
  gtk_container_add (GTK_CONTAINER (button_default), alignment13);

  hbox33 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox33);
  gtk_container_add (GTK_CONTAINER (alignment13), hbox33);

  image13 = gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image13);
  gtk_box_pack_start (GTK_BOX (hbox33), image13, FALSE, FALSE, 0);

  label48 = gtk_label_new_with_mnemonic (_("_Default"));
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (hbox33), label48, FALSE, FALSE, 0);

  button_undo = gtk_button_new ();
  gtk_widget_show (button_undo);
  gtk_box_pack_start (GTK_BOX (hbox8), button_undo, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_undo), 4);
  gtk_widget_set_sensitive (button_undo, FALSE);

  alignment9 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment9);
  gtk_container_add (GTK_CONTAINER (button_undo), alignment9);

  hbox27 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox27);
  gtk_container_add (GTK_CONTAINER (alignment9), hbox27);

  image9 = gtk_image_new_from_stock ("gtk-undo", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox27), image9, FALSE, FALSE, 0);

  label42 = gtk_label_new_with_mnemonic (_("_Undo"));
  gtk_widget_show (label42);
  gtk_box_pack_start (GTK_BOX (hbox27), label42, FALSE, FALSE, 0);

  button_apply = gtk_button_new ();
  gtk_widget_show (button_apply);
  gtk_box_pack_start (GTK_BOX (hbox8), button_apply, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_apply), 4);
  gtk_widget_set_sensitive (button_apply, FALSE);

  alignment5 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment5);
  gtk_container_add (GTK_CONTAINER (button_apply), alignment5);

  hbox23 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox23);
  gtk_container_add (GTK_CONTAINER (alignment5), hbox23);

  image5 = gtk_image_new_from_stock ("gtk-apply", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image5);
  gtk_box_pack_start (GTK_BOX (hbox23), image5, FALSE, FALSE, 0);

  label38 = gtk_label_new_with_mnemonic (_("_Apply"));
  gtk_widget_show (label38);
  gtk_box_pack_start (GTK_BOX (hbox23), label38, FALSE, FALSE, 0);

  button_done = gtk_button_new ();
  gtk_widget_show (button_done);
  gtk_box_pack_start (GTK_BOX (hbox8), button_done, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_done), 4);

  alignment14 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment14);
  gtk_container_add (GTK_CONTAINER (button_done), alignment14);

  hbox34 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox34);
  gtk_container_add (GTK_CONTAINER (alignment14), hbox34);

  image14 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image14);
  gtk_box_pack_start (GTK_BOX (hbox34), image14, FALSE, FALSE, 0);

  label49 = gtk_label_new_with_mnemonic (_("_Done"));
  gtk_widget_show (label49);
  gtk_box_pack_start (GTK_BOX (hbox34), label49, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) window_options, "destroy",
                    G_CALLBACK (on_window_options_destroy),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_VB_mode, "changed",
                    G_CALLBACK (on_comboboxentry_VB_mode_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_RB_auto_mode, "changed",
                    G_CALLBACK (on_comboboxentry_RB_auto_mode_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_RB_auto_stime, "changed",
                    G_CALLBACK (on_comboboxentry_RB_auto_stime_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_RB_auto_etime, "changed",
                    G_CALLBACK (on_comboboxentry_RB_auto_etime_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_RB_auto_beep, "changed",
                    G_CALLBACK (on_comboboxentry_RB_auto_beep_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_FS_mode, "changed",
                    G_CALLBACK (on_comboboxentry_FS_mode_changed),
                    NULL);
  g_signal_connect ((gpointer) spinbutton_FS_tone, "changed",
                    G_CALLBACK (on_spinbutton_FS_tone_changed),
                    NULL);
  g_signal_connect ((gpointer) spinbutton_FS_duration, "changed",
                    G_CALLBACK (on_spinbutton_FS_duration_changed),
                    NULL);
  g_signal_connect ((gpointer) comboboxentry_CP_mode, "changed",
                    G_CALLBACK (on_comboboxentry_CP_mode_changed),
                    NULL);
  g_signal_connect ((gpointer) button_default, "clicked",
                    G_CALLBACK (on_button_default_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_undo, "clicked",
                    G_CALLBACK (on_button_undo_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_apply, "clicked",
                    G_CALLBACK (on_button_apply_clicked),
                    NULL);
  g_signal_connect ((gpointer) button_done, "clicked",
                    G_CALLBACK (on_button_done_clicked),
                    NULL);

  HOOKUP_OBJECT_NO_REF (window_options, window_options, "window_options");
  HOOKUP_OBJECT (window_options, vbox4, "vbox4");
  HOOKUP_OBJECT (window_options, hseparator2, "hseparator2");
  HOOKUP_OBJECT (window_options, label50, "label50");
  HOOKUP_OBJECT (window_options, hseparator6, "hseparator6");
  HOOKUP_OBJECT (window_options, hbox11, "hbox11");
  HOOKUP_OBJECT (window_options, label26, "label26");
  HOOKUP_OBJECT (window_options, comboboxentry_VB_mode, "comboboxentry_VB_mode");
  HOOKUP_OBJECT (window_options, hseparator3, "hseparator3");
  HOOKUP_OBJECT (window_options, hbox12, "hbox12");
  HOOKUP_OBJECT (window_options, label27, "label27");
  HOOKUP_OBJECT (window_options, comboboxentry_RB_auto_mode, "comboboxentry_RB_auto_mode");
  HOOKUP_OBJECT (window_options, hbox16, "hbox16");
  HOOKUP_OBJECT (window_options, label30, "label30");
  HOOKUP_OBJECT (window_options, hbox31, "hbox31");
  HOOKUP_OBJECT (window_options, comboboxentry_RB_auto_stime, "comboboxentry_RB_auto_stime");
  HOOKUP_OBJECT (window_options, label46, "label46");
  HOOKUP_OBJECT (window_options, hbox17, "hbox17");
  HOOKUP_OBJECT (window_options, label31, "label31");
  HOOKUP_OBJECT (window_options, hbox30, "hbox30");
  HOOKUP_OBJECT (window_options, comboboxentry_RB_auto_etime, "comboboxentry_RB_auto_etime");
  HOOKUP_OBJECT (window_options, label45, "label45");
  HOOKUP_OBJECT (window_options, hbox18, "hbox18");
  HOOKUP_OBJECT (window_options, label32, "label32");
  HOOKUP_OBJECT (window_options, comboboxentry_RB_auto_beep, "comboboxentry_RB_auto_beep");
  HOOKUP_OBJECT (window_options, hseparator4, "hseparator4");
  HOOKUP_OBJECT (window_options, hbox13, "hbox13");
  HOOKUP_OBJECT (window_options, label28, "label28");
  HOOKUP_OBJECT (window_options, comboboxentry_FS_mode, "comboboxentry_FS_mode");
  HOOKUP_OBJECT (window_options, hbox19, "hbox19");
  HOOKUP_OBJECT (window_options, label34, "label34");
  HOOKUP_OBJECT (window_options, spinbutton_FS_tone, "spinbutton_FS_tone");
  HOOKUP_OBJECT (window_options, hbox20, "hbox20");
  HOOKUP_OBJECT (window_options, label35, "label35");
  HOOKUP_OBJECT (window_options, spinbutton_FS_duration, "spinbutton_FS_duration");
  HOOKUP_OBJECT (window_options, hseparator5, "hseparator5");
  HOOKUP_OBJECT (window_options, hbox14, "hbox14");
  HOOKUP_OBJECT (window_options, label29, "label29");
  HOOKUP_OBJECT (window_options, comboboxentry_CP_mode, "comboboxentry_CP_mode");
  HOOKUP_OBJECT (window_options, hseparator1, "hseparator1");
  HOOKUP_OBJECT (window_options, hbox8, "hbox8");
  HOOKUP_OBJECT (window_options, button_default, "button_default");
  HOOKUP_OBJECT (window_options, alignment13, "alignment13");
  HOOKUP_OBJECT (window_options, hbox33, "hbox33");
  HOOKUP_OBJECT (window_options, image13, "image13");
  HOOKUP_OBJECT (window_options, label48, "label48");
  HOOKUP_OBJECT (window_options, button_undo, "button_undo");
  HOOKUP_OBJECT (window_options, alignment9, "alignment9");
  HOOKUP_OBJECT (window_options, hbox27, "hbox27");
  HOOKUP_OBJECT (window_options, image9, "image9");
  HOOKUP_OBJECT (window_options, label42, "label42");
  HOOKUP_OBJECT (window_options, button_apply, "button_apply");
  HOOKUP_OBJECT (window_options, alignment5, "alignment5");
  HOOKUP_OBJECT (window_options, hbox23, "hbox23");
  HOOKUP_OBJECT (window_options, image5, "image5");
  HOOKUP_OBJECT (window_options, label38, "label38");
  HOOKUP_OBJECT (window_options, button_done, "button_done");
  HOOKUP_OBJECT (window_options, alignment14, "alignment14");
  HOOKUP_OBJECT (window_options, hbox34, "hbox34");
  HOOKUP_OBJECT (window_options, image14, "image14");
  HOOKUP_OBJECT (window_options, label49, "label49");

  return window_options;
}

