/*
 * tshiddev.c
 *
 */

#include <gtk/gtk.h>

#include <stdio.h>
#include <fcntl.h>
#include <linux/input.h>

#include "tsusbhid.h"
#include "tsevdev.h"

static gint		tshiddev_fd = -1;
static tshidioc_id_type	tshiddev_id[TSHIDIOC_ID_SIZE];

gint
tshiddev_open(gint devnum)
{
	gint ret;
	char deviceName[30];

	snprintf(deviceName, sizeof(deviceName), TSEVDEV_DEVICE_NAME "%d", devnum);

	ret = open (deviceName, O_RDWR );
	if ( ret < 0 ) {
		return FALSE;
	}

	tshiddev_fd = ret;

	return TRUE;
}

void
tshiddev_close(void)
{
	close(tshiddev_fd);
}

gint
tshiddev_get_id(gint devnum)
{
	gint ret;

	ret = tshiddev_open(devnum);

	if ( ret < 0 ) {
		return -1;
	}

	ret = ioctl(tshiddev_fd, TSHIDIOC_GET_ID, &tshiddev_id);

	tshiddev_close();

	if ( ret != 0 ) {
		return ret;
	}

	return 0;
}

gint
tshiddev_get_id_string(gint devnum, gchar *buffer, gint buffer_size)
{
	gint ret;

	ret = tshiddev_get_id(devnum);

	if ( ret == 0 ) {
		snprintf(buffer,buffer_size,"TS2005F-USB %04X-%04X-%04X %d:%d",
			tshiddev_id[TSHIDIOC_ID_VENDOR],
			tshiddev_id[TSHIDIOC_ID_PRODUCT],
			tshiddev_id[TSHIDIOC_ID_REVISION],
			tshiddev_id[TSHIDIOC_ID_BUSNUM],
			tshiddev_id[TSHIDIOC_ID_DEVNUM]
			);

	}

	return 0;

}

gint
tshiddev_get_feature(struct tsusb_feature_report *feature)
{
	return ioctl(tshiddev_fd, TSHIDIOC_GET_FEATURE, feature);
}

gint
tshiddev_set_feature(struct tsusb_feature_report *feature)
{
	return ioctl(tshiddev_fd, TSHIDIOC_SET_FEATURE, feature);
}

gint
tshiddev_enable(void)
{
	return ioctl(tshiddev_fd, TSHIDIOC_SET_ENABLE);
}

gint
tshiddev_disable(void)
{
	return ioctl(tshiddev_fd, TSHIDIOC_SET_DISABLE);
}
